=== debian/changelog ===
uhd (4.6.0.0+ds1-5.1ubuntu0.24.04.1) noble; urgency=medium

  * d/control: Fix runtime dependency. (LP: #2060882)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 30 Apr 2024 21:39:22 +0100
